#ifndef TDE_WIDGETS_PROGRESSBAR_H
#define TDE_WIDGETS_PROGRESSBAR_H

#include <QWidget>
#include <QProgressBar>

#include "common.h"
#include "opaque.h"

// -- TDE NAMESPACE ----------------------------------------------------

namespace TDE {

// -- Widgets NAMESPACE ------------------------------------------------

namespace Widgets {

/*!
 * \class ProgressBar
 * \brief Widget for displaying a DataStore variable value through a progress bar.
 *
 * \see DataStore
 * \see WidgetInfo
 */
class ProgressBar : public QProgressBar
{
    Q_OBJECT
	Q_PROPERTY(QString variableName READ variableName WRITE setVariableName NOTIFY variableChanged)
    Q_PROPERTY(bool trace READ trace WRITE setTrace NOTIFY traceChanged)
    Q_PROPERTY(int refresh READ refresh WRITE setRefresh NOTIFY refreshChanged)
    Q_PROPERTY(bool raw READ raw WRITE setRaw NOTIFY rawChanged)
    Q_PROPERTY(QString nativeUnit READ nativeUnit)
    Q_PROPERTY(QString displayUnit READ displayUnit WRITE setDisplayUnit NOTIFY displayUnitChanged)

public:
    ProgressBar(QWidget *parent = 0);
    virtual ~ProgressBar();

    SHARED_PTR<TDE::DataStore> dataStore();
    ProgressBar& setDataStore(SHARED_PTR<TDE::DataStore> ds_p);
    ProgressBar& setVariableName(const std::string& name);

    int     variableIndex() const;
    const TDE::VariableDescr& variableDescr() const;

    // properties getters/setters

    QString variableName() const;
    void    setVariableName(const QString&);

    bool trace() const;
    bool setTrace(bool value = true);

    int refresh() const;
    int setRefresh(int value = 0);

    QString nativeUnit() const;
    QString displayUnit() const;
    void    setDisplayUnit(const QString& value);

    TDE::DisplayUnitPtr nativeUnitPtr() const;
    TDE::DisplayUnitPtr displayUnitPtr() const;

    bool raw() const;
    bool setRaw(bool value = true);

    virtual QString text() const;
    int decimals;

signals:
    void variableChanged(QString);
    void integerVariableValueChanged(int);
    void floatVariableValueChanged(float);
    void traceChanged(bool);                // trace option changed
    void refreshChanged(int);               // refresh value changed
    void rawChanged(bool);                  // raw option changed
    void displayUnitChanged(QString);       // display unit changed

public slots:
    void ui2ds();    // set DataStore variable with value from UI
    void ds2ui();    // set UI with value from DataStore

private:
	SHARED_PTR<WidgetInfo> m_winfo;
    bool firstTime;

protected:
    virtual void showEvent(QShowEvent *event);
};

} /* end of namespace Widgets */

} /* end of namespace TDE */

#endif /* TDE_WIDGETS_PROGRESSBAR_H */
